﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ELTE.Algorithms.BinarySearchTree.Operations
{
    public partial class TreeForm : Form
    {
        private BinarySearchTree _Tree; // bináris keresőfa

        public TreeForm()
        {
            InitializeComponent();

            _Tree = new BinarySearchTree(); // új bináris keresőfa
        }

        private void ButtonSearch_Click(object sender, EventArgs e)
        {
            TreeNode result = _Tree.Search(Convert.ToInt32(_NumericKey.Value)); // művelet lefuttatása és eredmény lekérdezése
            _Panel.Refresh(); // panel frissítése
            if (result == null) // ha az eredmény null
                _StatusLabel.Text = "Key not found!";
            else
                _StatusLabel.Text = "Key found (marked red).";
        }

        private void ButtonAdd_Click(object sender, EventArgs e)
        {
            TreeNode result = _Tree.Insert(Convert.ToInt32(_NumericKey.Value));
            _Panel.Refresh();
            if (result == null)
                _StatusLabel.Text = "Insert failed, key already in tree!";
            else
                _StatusLabel.Text = "Insert succeded.";
        }

        private void ButtonRemove_Click(object sender, EventArgs e)
        {
            TreeNode result = _Tree.Delete(Convert.ToInt32(_NumericKey.Value));
            _Panel.Refresh();
            if (result == null)
                _StatusLabel.Text = "Key not found, can't delete!";
            else
                _StatusLabel.Text = "Delete succeded.";
        }

        private void ButtonMin_Click(object sender, EventArgs e)
        {
            TreeNode result = _Tree.Min();
            _Panel.Refresh();
            if (result == null)
                _StatusLabel.Text = "Tree is empty!";
            else
                _StatusLabel.Text = "Minimum key is: " + result.Key.ToString();
        }

        private void ButtonMax_Click(object sender, EventArgs e)
        {
            TreeNode result = _Tree.Max();
            _Panel.Refresh();
            if (result == null)
                _StatusLabel.Text = "Tree is empty!";
            else
                _StatusLabel.Text = "Maximum key is: " + result.Key.ToString();
        }

        private void ButtonPrev_Click(object sender, EventArgs e)
        {
            TreeNode result = _Tree.Previous();
            _Panel.Refresh();
            if (result == null)
                _StatusLabel.Text = "Tree is empty!";
            else
                _StatusLabel.Text = "Previous key is: " + result.Key.ToString();
        }

        private void ButtonNext_Click(object sender, EventArgs e)
        {
            TreeNode result = _Tree.Next();
            _Panel.Refresh();
            if (result == null)
                _StatusLabel.Text = "Tree is empty!";
            else
                _StatusLabel.Text = "Next key is: " + result.Key.ToString();
        }

        private void ButtonClear_Click(object sender, EventArgs e)
        {
            _Tree.Clear();
            _Panel.Refresh();
            _StatusLabel.Text = "Tree cleared.";
        }
        private void TreePanel_Paint(object sender, PaintEventArgs e) // panel frissítésének eseménykezelője
        {
            // automatikusan fehérre festi a hátteret
            e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias; // élsimítás beállítása
            _Tree.Draw(e.Graphics, _Panel.Width); // fa kirajzolása
        }
    }
}
